org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class IndexStep<S,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<S,E>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.IndexStep<S,E>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<E>>, Step<S,E>, Configuring, Parameterizing, TraversalParent

      public class IndexStep<S,E>
      extends MapStep<S,E>
      implements TraversalParent, Configuring

  Author:
    Daniel Kuppitz (http://gremlin.guru)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `IndexStep.IndexerType` Type of the index as it corresponds to the associated `WithOptions.list` and `WithOptions.map`.

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IndexStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configure(Object... keyValues)` Accept a configuration to the `Step`.
    `Function<Iterator<?>,Object>` | `getIndexer()`
    `IndexStep.IndexerType` | `getIndexerType()` Gets the type of indexer that is configured for this step.
    `Parameters` | `getParameters()` Gets the parameters on the step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `protected E` | `map(Traverser.Admin<S> traverser)`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, clone, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, reset, setId, setNextStep, setPreviousStep, setTraversal, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getLocalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### IndexStep

          public IndexStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### getIndexer

          public Function<Iterator<?>,Object> getIndexer()

    - #### getIndexerType

          public IndexStep.IndexerType getIndexerType()

      Gets the type of indexer that is configured for this step.

    - #### map

          protected E map(Traverser.Admin<S> traverser)

      Specified by:
        `map` in class `MapStep<S,E>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,E>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,E>`
      Returns:
        the set of requirements

    - #### configure

          public void configure(Object... keyValues)

      Description copied from interface: `Configuring`
      Accept a configuration to the `Step`. Note that this interface extends `Parameterizing` and so there is an expectation that the `Step` implementation will have a `Parameters` instance that will house any values passed to this method. Storing these configurations in `Parameters` is not a requirement however, IF the configuration is an expected option for the step and can be stored on a member field that can be accessed on the step by more direct means (i.e. like a getter method).
      Specified by:
        `configure` in interface `Configuring`

    - #### getParameters

          public Parameters getParameters()

      Description copied from interface: `Parameterizing`
      Gets the parameters on the step.
      Specified by:
        `getParameters` in interface `Parameterizing`

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.